/*
 *   update.c  
 *   
 */

#include <stdio.h>
#include <string.h>
#ifndef VMS
#include <sgtty.h>
#else VMS
#include <libdef.h>
#include <lib$routines.h>
#include <jpidef.h>
#include <ssdef.h>
#include <descrip.h>
#include <iodef.h>
#include <ttdef.h>
#endif VMS
#include <regexp.h>
#include <ctype.h>
#include <signal.h>
#include <sys/file.h>
#ifndef VMS
#include <pwd.h>
#endif VMS
#include <dixie.h>

extern char answer[MAX_PKT_SIZE];
extern char *attrlist[];
extern char *readattrlist[];
extern int rc,matches,iidflag, lastname,limit;
extern char original_search_base[];
extern char *search_base, oldoptions;

int update()
{
     extern char *malloc(), *disambiguate();
     extern char *getenv();
#ifdef VMS
     extern void update_help(char *, char *);
#else VMS
     extern void update_help();
#endif VMS
     extern int returnme();
     char **values;
     int retval, l;
     extern FILE *morefp;
     extern char *search_base;
     extern char *malloc(), *disambiguate();
     extern char *getenv(), inputbuf[255], filterstring[255];
     extern char *termtype, *crptr, *who;
     extern void password_help(), init_help();
     extern void email_help();
     char *iid, *theentry, *email_address;
     regexp *r;
     
     termtype = getenv("TERM");
     signal(SIGINT, returnme);
     if ((search_base = (char *) malloc(strlen(original_search_base)+1)) == NULL){
	  perror("malloc");
	  exit(0);
     }
     strcpy(search_base, original_search_base);
     
     printf("\nPlease enter your name or unique ID below. For example,\n");
     printf("\"Rakesh Patel\", \"Francis Lawrence\",\"+RP6+\", or \"+FLL2+\".\n");
     printf("After you enter your name or unique ID, a search will be done\n");
     printf("for your entry. If multiple matches occur, you will be given a\n");
     printf("list of up to %d names to choose from.\n",limit);
     printf("\nPlease enter your name or unique ID,\n");
     printf("or hit return/enter to return to menu: ");
     bzero(inputbuf,sizeof(inputbuf));
     fgets(inputbuf,sizeof(inputbuf),stdin);
     crptr = strchr(inputbuf,'\n');
     if (crptr)
       *crptr = '\0';
     if ( *inputbuf == '\0' )
       return;
     r = regcomp(".*[0-9].*");
     iidflag =  regexec(r, inputbuf);
     if ( !iidflag && strchr(inputbuf,' ') == 0)
       lastname = 1;
     else
       lastname = 0;
     
     bzero(filterstring,255);
     
     if ( lastname && iidflag != 1) {
	  strcpy(filterstring,"sn=");
	  strcat(filterstring,inputbuf);
     }
     else {
	  if ( iidflag ) {
	       if ( inputbuf[0] != '+' ) {
		    strcpy(filterstring,"uid=+");
		    strcat(filterstring,inputbuf);
		    strcat(filterstring,"+");
	       }
	       else {
		    strcpy(filterstring,"uid=");
		    strcat(filterstring,inputbuf);
	       }
	  }
	  else {
	       strcpy(filterstring,"cn~=");
	       strcat(filterstring,inputbuf);
	  }
     }
     rc = dxi_search(search_base,DXI_SRCH_SUBTREE,filterstring,attrlist,answer);
     if ( rc == -1) {
	  dxi_perror("Search failed");
	  return;
     }
     matches = dxi_matches(answer);
     if ( matches == 0) {
	  printf("\nNo matches were found.\n\n");
	  return;
     }
     if (matches > 1 ) {
#ifdef VMS
	  morefp = stdout;
#else
	  if ( termtype != NULL && strncmp(termtype,"ibm-32",6) == 0)
	    morefp = stdout;
	  else
	    morefp = popen("/usr/ucb/more","w");
#endif
	  
	  who = disambiguate();
     }
     else
       who = dxi_getdn(dxi_firstentry(answer));
     
     if (who != NULL) {
	  rc = dxi_read (who, readattrlist, answer);
	  if ( rc == -1) {
#ifndef VMS
	       pclose(morefp);
#endif VMS
	       dxi_perror("Read failed");
	       return;
	  }
	  
	  theentry = dxi_firstentry(answer);
	  values = dxi_getvalues(theentry,"mail");
	  if (values )
	    for ( l = 0 ; values[l] != NULL ; l++);
	  if (!values || l == 0) {
	       email_address = NULL;
	  }
	  else 
	    email_address = values[0];
	  
	  values = dxi_getvalues(theentry,"uid");
	  if (values )
	    iid = values[0];
	  else
	    iid = NULL;
	  if ( iid && strchr(iid,'+') == NULL){
	       iid = NULL;
	  }
	  
	  rc = dxi_compare ( who ,"userPassword", "foo" );
	  if ( rc == -1 ) {
	       if ( dxi_errno == DXI_NEX_ATTR ) {
#ifndef VMS
		    pclose(morefp);
#endif VMS
		    init_help(iid,email_address);
		    return;
	       }
	       else{
		         if ( dxi_errno != DXI_COMPAREFAILED) {
			   dxi_perror("Compare failed");
			   return;
			 }
	       }
	  }
	  retval = update_bind(who, "\nWhitePages Password for");   
	  if (retval < 0 || retval > 1) {
	       if ( retval == DXI_NEX_ATTR )
		 init_help(iid,email_address);
	       return;
	  }
	  rc = dxi_read (who, readattrlist, answer);
	  if ( rc == -1) {
#ifndef VMS
	       pclose(morefp);
#endif
	       dxi_perror("Read failed");
	       return;
	  }
	  printf("\nThis is your current entry:\n\n");
	  /* dump the answer if OK */
	  parse_answer(answer);
	  print_person();
	  printf("\nHit return/enter to continue:");
	  bzero(inputbuf,sizeof(inputbuf));
	  fgets(inputbuf,sizeof(inputbuf),stdin);
	  update_set_attrib(who, iid , email_address);
     }
     else
       return;
}

update_bind(bname, prefix)
     char *bname, *prefix;
{
     register char *temp;
     int rc;
     char *passwd, *prompt;
     extern unsigned long inet_addr();
     extern char *malloc(), *getpass();
     extern int dxi_errno;
     
     temp = dxi_lastdncomp(bname);
     if ((prompt = malloc(strlen(prefix) + strlen(temp) + 3)) == NULL) {
	  perror("malloc");
	  exit(0);
     }
     sprintf(prompt, "%s %s? ", prefix, temp);
     passwd = getpass(prompt);
     if ( passwd == NULL || strlen(passwd) == 0 ) {
	  return(-1);
     }
     
     free(prompt);
     
     /* humor Tim */
     printf("\nAuthenticating . . . (one moment please)\n");
     fflush(stdout);
     
     rc = 0;
     rc = dxi_bind(bname,passwd);
     /* see if it was successful */
     if ( rc != 0) {
	  dxi_perror("Authentication failed");
	  return(dxi_errno);
     }
     return(1);
}


update_set_attrib(sname,iid , email_address)
     char *sname, *iid, *email_address;
{
     char c[255], *ubuff, *attr, *who, *what[2], *theentry, **values, tempbuf[255];
     int i, rc;
     int hell_freezes_over = 1, nohome;
     extern char * get_attr_val();
     extern set_pw(), print_entry();
     static char *alist[] = {"mail", "homePhone", "homePostalAddress", "description"};
     static char *alist2[] = {"mail", "description"};
     
     if ( strlen(sname) > 60 && strncmp(sname,"c=US@st=New Jersey@o=Rutgers University@ou=Student Directory",60) == 0 )
       nohome = 1;
     else
       nohome = 0;
     do {
	  bzero(what, sizeof(what));
	  attr="";
	  if ( nohome )
	    printf("\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s",
		   "Please Select from the following list to ether modify ",
		   "an attribute or choose an option.                     ",
		   "                                                      ",
		   "  1. E-mail Address                                   ",
		   "  2. Personal Description                             ",
		   "                                                      ",
		   "Other options:                                        ",
		   "                                                      ",
		   "  3. Display complete entry                           ",
		   "  4. Change WhitePages password                       ",
		   "  5. Clear one of the above attributes                ",
		   "  6. Exit Update                                      ",
		   "                                                      ",
		   "Type the number corresponding to the attribute        ",
		   "to modify or the option to execute, then press return/enter: ");
	  else
	    printf("\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s",
		   "Please Select from the following list to ether modify ",
		   "an attribute or choose an option.                     ",
		   "                                                      ",
		   "  1. E-mail Address                                   ",
		   "  2. Home Telephone Number                            ",
		   "  3. Home Address                                     ",
		   "  4. Personal Description                             ",
		   "                                                      ",
		   "Other options:                                        ",
		   "                                                      ",
		   "  5. Display complete entry                           ",
		   "  6. Change WhitePages password                       ",
		   "  7. Clear one of the above attributes                ",
		   "  8. Exit Update                                      ",
		   "                                                      ",
		   "Type the number corresponding to the attribute        ",
		   "to modify or the option to execute, then press return/enter: ");
	  what[0] = (char *) malloc(255);
	  what[1] = NULL;
	  fgets(c,255,stdin);
	  printf("\n");
	  if ( nohome ) {
	       if (*c > '0' && *c < '3') {
		    attr=alist2[(*c-'0')-1];
		    strcpy(what[0],attr);
		    strcat(what[0],"=");
	       } 
	       else if (*c == '3') {
		    rc = dxi_read(sname,readattrlist,answer);
		    if ( rc == -1) {
#ifndef VMS
			 pclose(morefp);
#endif
			 dxi_perror("Read failed");
			 return(-1);
		    }
		    /* dump the answer if OK */
		    
		    parse_answer(answer);
		    print_person();
		    printf("\nHit return/enter to continue:");
		    bzero(tempbuf,sizeof(tempbuf));
		    fgets(tempbuf,sizeof(tempbuf),stdin);
/*		    free(tempbuf); */
		    continue;
	       }
	       else if (*c == '4') {
		    who = dxi_lastdncomp(sname);
		    update_help(iid,email_address);
		    continue;
	       }
	       else if (*c == '5') {
		    clear_attr(sname, nohome);
		    continue;
	       }
	       else if (*c == '6' || *c == 'q')
		 return(0);
	       else {
		    printf("\nInvalid Attribute Number\n\n");
		    continue;
	       }
	  }
	  else {
	       if (*c > '0' && *c < '5') {
		    attr=alist[(*c-'0')-1];
		    strcpy(what[0],attr);
		    strcat(what[0],"=");
	       } 
	       else if (*c == '5') {
		    rc = dxi_read(sname,readattrlist,answer);
		    if ( rc == -1) {
#ifndef VMS
			 pclose(morefp);
#endif
			 dxi_perror("Read failed");
			 return(-1);
		    }
		    /* dump the answer if OK */
		    
		    parse_answer(answer);
		    print_person();
		    printf("\nHit return/enter to continue:");
		    bzero(tempbuf,sizeof(tempbuf));
		    fgets(tempbuf,sizeof(tempbuf),stdin);
/*		    free(tempbuf); */
		    continue;
	       }
	       else if (*c == '6') {
		    who = dxi_lastdncomp(sname);
		    update_help(iid,email_address);
		    continue;
	       }
	       else if (*c == '7') {
		    clear_attr(sname, nohome);
		    continue;
	       }
	       else if (*c == '8' || *c == 'q')
		 return(0);
	       else {
		    printf("\nInvalid Attribute Number\n\n");
		    continue;
	       }
	  }
	  theentry = dxi_firstentry(answer);
	  values = dxi_getvalues(theentry,attr);
	  
	  if ( values ) {
	       printf("\nCurrent value is: ");
	       for (i=0;values[i] != NULL ; i++) {
		    printf("%s ",values[i]);
	       }
	       printf("\n\n");
	  }
	  ubuff= get_attr_val(attr);
	  if ( ubuff )
	    strcat(what[0], ubuff);
	  else
	    continue;
	  rc = dxi_modify(sname,what);
	  if ( rc == -1) {
	       printf("Could not contact server.\n");
	       return(-1);
	  }
	  rc = dxi_read (sname, readattrlist, answer);
	  /* dump the answer if OK */
	  if (rc == -1 ) {
	       dxi_perror("Read failed");
	  }
	  else {
	       theentry = dxi_firstentry(answer);
	       values = dxi_getvalues(theentry,attr);
	       if ( values ) {
		    printf("\nThe new value is: ");
		    for (i=0;values[i] != NULL ; i++) {
			 printf("%s ",values[i]);
		    }
		    printf("\n\n");
	       }
	  }
	  
     } while (hell_freezes_over);
}

static char input[255];


/*
 *  stolen by Tim so we could change the size of a password
 */

static char pbuf[513];

char * getpass(prompt)
     char *prompt;
{
     char i, j, k;
#ifndef VMS
     struct sgttyb ttyb;
#endif VMS
     int flags;
     register char *p;
     register int c;
     FILE *fi;
#ifdef VMS
#define characteristics_size 3
#define csize_in_bytes 12
    $DESCRIPTOR (tt_desc, "SYS$INPUT");
    unsigned short tt_chan;
    unsigned long tt_efn;
    unsigned long tt_iosb[2];
    unsigned long old_buf[characteristics_size];
    unsigned long new_buf[characteristics_size];
#endif
#ifndef sun
     int (*signal())();
     int (*sig)();
#else
     void (*signal())();
     void (*sig)();
#endif
     
#ifdef VMS
     fi = stdin;
#else
     if ((fi = fdopen(open("/dev/tty", 2), "r")) == NULL)
       fi = stdin;
     else
       setbuf(fi, (char *)NULL);
#endif
     sig = signal(SIGINT, SIG_IGN);

#ifdef VMS
    lib$get_ef (
      &tt_efn);
    sys$assign (
        &tt_desc, 
        &tt_chan, 
        0, 
        0);
    sys$qiow (
        tt_efn, 
        tt_chan, 
        IO$_SENSEMODE, 
        &tt_iosb, 
        0, 
        0, 
        old_buf, 
        csize_in_bytes, 
        0,
        0, 
        0, 
        0);
    lib$movc3 (
        &csize_in_bytes, 
        old_buf, 
        new_buf);
    new_buf[1] = new_buf[1] | TT$M_NOECHO;
    sys$qiow (
        tt_efn, 
        tt_chan, 
        IO$_SETMODE, 
        &tt_iosb, 
        0, 
        0, 
        new_buf, 
        csize_in_bytes, 
        0,
        0, 
        0, 
        0);
#else VMS
     gtty(fileno(fi), &ttyb);
     flags = ttyb.sg_flags;
     ttyb.sg_flags &= ~ECHO;
     stty(fileno(fi), &ttyb);
#endif VMS
     fprintf(stdout, "%s", prompt); fflush(stdout);
#ifndef VMS
     if (fi == stdin) {
	  printf("%c%c%c", 255, 251, 1);
	  fflush(stdout);
	  scanf("%c%c%c", &i, &j, &k);
	  fflush(stdin);
     }
#endif
     for (p=pbuf; (c = getc(fi))!='\n' && c!=EOF;) {
	  if (c == '\r')
	    break;
	  if (p < &pbuf[512])
	    *p++ = c;
     }
     *p = '\0';
     if (*(p - 1) == '\r')
       *(p - 1) = '\0';
#ifndef VMS
     if (fi == stdin) {
	  printf("%c%c%c", 255, 252, 1);
	  fflush(stdout);
	  scanf("%c%c%c", &i, &j, &k);
	  fflush(stdin);
	  printf("\n"); fflush(stdout);
     }
#endif VMS
     fprintf(stdout, "\n"); fflush(stdout);
#ifdef VMS
    sys$qiow (
        tt_efn, 
        tt_chan, 
        IO$_SETMODE, 
        &tt_iosb, 
        0, 
        0, 
        old_buf, 
        csize_in_bytes, 
        0,
        0, 
        0, 
        0);
#else VMS
     ttyb.sg_flags = flags;
     stty(fileno(fi), &ttyb);
#endif VMS
     signal(SIGINT, sig);
     if (fi != stdin)
       fclose(fi);
     return(pbuf);
}


char * get_attr_val(attr)
     char *attr;
{
     register char *s;
     register int len;
     int i;
     
     bzero(input, sizeof(input));
     if (!strcmp(attr, "homePostalAddress") || !strcmp(attr, "postalAddress") ) {
	  printf("  Enter your address (RETURN to stop, 6 30-char lines max)  [return/enter on first line to leave alone]\n");
	  for (s = input, i = 1; i < 7; i++) {
	       printf("%1d> ", i);
	       fflush(stdout);
	       fgets(s, 29, stdin);
	       if ((len = strlen(s)) < 2) {
		    *(s-1) = '\0';
		    break;
	       }
	       else {
		    s += len;
		    *(s-1) = '$';
	       }
	  }
	  for (s = input; *s != '\0'; s++)
	    if (*s == '#')
	      *s = ' ';
     }
     else if (!strcmp(attr, "description")) {
	  printf("   Enter the description info [return/enter to leave alone]\n");
	  printf("> ");
	  fflush(stdout);
	  fgets(input, sizeof(input) - 1, stdin);
	  *(input + strlen(input) - 1) = '\0';
     }
     else if (!strcmp(attr, "mail")) {
	  printf("The electronic mail address must be in the format {username}@{hostname},\n");
	  printf("where the host name is contains the full internet domain\n");
	  printf("(generally ending in .rutgers.edu at Rutgers), for example:\n");
	  printf("camayocs@whitepages.rutgers.edu\n\n");
	  printf("   Enter your electronic mail address [return/enter to leave alone]\n");
	  printf("> ");
	  fflush(stdout);
	  fgets(input, sizeof(input) - 1, stdin);
	  *(input + strlen(input) - 1) = '\0';
     }
     else if (!strcmp(attr, "telephoneNumber")) {
	  printf("Please enter your phone number in international format.\n");
	  printf("International format consists of +{contry-code} {area code}-{phone}\n");
	  printf("The US country code is \"1\", so an example number is +1 908-932-3436\n");
	  printf("   Enter your phone number [return/enter to leave alone]\n\n");
	  printf("> ");
	  fflush(stdout);
	  fgets(input, sizeof(input) - 1, stdin);
	  *(input + strlen(input) - 1) = '\0';
     }
     else if (!strcmp(attr, "homePhone")) {
	  printf("Please enter your phone number in international format.\n");
	  printf("International format consists of +{contry-code} {area code}-{phone}\n");
	  printf("The US country code is \"1\", so an example number is +1 908-932-3436\n");
	  printf("   Enter your phone number [return/enter to leave alone]\n\n");
	  printf("> ");
	  fflush(stdout);
	  fgets(input, sizeof(input) - 1, stdin);
	  *(input + strlen(input) - 1) = '\0';
     }
     else if (!strcmp(attr, "cn")) {
	  printf("   Enter your alias [return/enter to leave alone]\n");
	  printf("> ");
	  fflush(stdout);
	  fgets(input, sizeof(input) - 1, stdin);
	  *(input + strlen(input) - 1) = '\0';
     }
     else if (!strcmp(attr, "title")) {
	  printf("   Enter your title [return/enter to leave alone]\n");
	  printf("> ");
	  fflush(stdout);
	  fgets(input, sizeof(input) - 1, stdin);
	  *(input + strlen(input) - 1) = '\0';
     }
     else
       printf("\tI don't recognize the \"%s\" keyword\n", attr);
     
     for (s = input; *s != '\0'; s++)
       /* truncate at junk */
       if (!isprint(*s))
	 *s = '\0';
     if ( strlen(input) == 0)
       return(NULL);
     else
       return(input);
}

void
  init_help(iid, email_address)
char *iid, *email_address;
{
     char inputbuf[255];
     extern void init_request();
     
     printf("\n\nIn order to update your entry, you need to set your WhitePages password.\n");
     printf("You can set the Whitepages password of your entry by electronic mail.\n");
     printf("This is done by sending mail to \"whitepages-init@whitepages.rutgers.edu\"\n");
     printf("with your unique ID (the +something+ after your name in WhitePages),\n");
     printf("the last 4 digits of your 9-digit Rutgers ID (usually Social Security Number),\n");
     printf("the password you wish to assign for your WhitePages entry (starting with\n");
     printf("\"password=\" - for example, \"password= ehT460dorws\" ), your date\n");
     printf("of birth (starting with \"birthdate=\" in the mm-dd-yy format\n");
     printf("for example, \"birthdate= 12-31-91\"), and optionally,\n");
     printf("your email address. Each of these must be supplied on a separate line.\n");
     if ( ! iid ) {
	  printf("\n*** Your entry does not contain a unique ID, please contact Rakesh Patel\n");
	  printf("by sending mail to camayocs@whitepages.rutgers.edu to have it checked! ***\n");
	  printf("\nType the return/enter key to continue:");
	  fgets(inputbuf,sizeof(inputbuf),stdin);
	  return;
     }
     printf("\nDo you wish to have the request sent for you? (y/n) [n]: ");
     fgets(inputbuf,sizeof(inputbuf),stdin);
     *(inputbuf + strlen(inputbuf) - 1) = '\0';
     if (*inputbuf == 'y' ) {
	  init_request(iid, email_address);
     }
     return;
}

void
  email_help()
{
     char inputbuf[255];
     printf("\n\n Your entry does not contain the location at which you receive\n");
     printf("electronic mail.\n\n  If you do not have a location at which you receive email,\n");
     printf("then you can not interactively update any fields of your entry. You can\n");
     printf("have the official information currently in your entry changed by filling out\n");
     printf("an appropriate form. Faculty and staff should contact their department to\n");
     printf("fill out an Address Directory Record (ADR) form to make any changes.\n\n");
     printf("If you have a location at which you receive electronic\n");
     printf("mail, then you should have your system administrator contact\n");
     printf("camayocs@whitepages.rutgers.edu in order to make the arrangements\n");
     printf("necessary to allow updates for your entry.\n\n");
     printf("Type return/enter when done: ");
     fgets(inputbuf,sizeof(inputbuf),stdin);
     return;
}

void
  init_request(iid, email_address)
char *iid, *email_address;
{
#ifdef VMS
     char initstring[255], inputbuf[255], *ssend, *newpass, *newpass2, thishost[512], *username, *this_address, tempfile[255], *bdate;
     FILE *temp;
     int pid, status, foo,fd, i, uid, mypid;
     char tempstring[255];
     char result[13];
     unsigned short reslen = 12;
     unsigned long stat;
     long itemcode = JPI$_USERNAME;
     unsigned long procid = 0;
     $DESCRIPTOR(username_desc,"");
     $DESCRIPTOR(command_desc,"");
#else VMS
     char initstring[255], inputbuf[255], *ssend, *newpass, *newpass2, thishost[512], *username, *this_address, tempfile[255], *bdate;
     FILE *temp;
     int pid, status, foo,fd, i, uid, mypid;
     struct passwd *pwent;
#endif VMS
     strcpy(initstring,"Init Request for ");
     strcat(initstring,iid);
     
     printf("\nYour unique ID is %s\n\n",iid);
     
     if ( email_address )
       printf("\nYour email address is %s\n\n",email_address);
     else {
	  if ( gethostname(thishost,512) != 0 ) {
	       printf("\nCan't find host name!\n");
	       perror("gethostname");
	       return;
	  };
#ifdef VMS
	  username = malloc(reslen);
	  if (!username) {
	    perror("malloc");
	    return;
	  };
          username_desc.dsc$a_pointer = result;
          username_desc.dsc$w_length = reslen;
          stat = lib$getjpi (
                               &itemcode, 
                               &procid,
                               0,
                               0,
                               &username_desc, 
                               &reslen);
          if (stat != SS$_NORMAL)
            {
              lib$signal(stat);
            };
          result[reslen] = '\0';
          strcpy(username,result);
          for (i = 0; i < reslen; i++)
            if (username[i] == ' ') break;
          username[i] = '\0';
#else VMS
	  uid = getuid();
	  pwent = getpwuid(uid);
	  username = pwent->pw_name;
#endif VMS
	  if ( strlen(username) <= 0 ) {
	       printf("\nCan't get user name!\n");
	       return;
	  }
	  this_address = malloc(strlen(username)+ strlen(thishost)+2);
	  if (!this_address) {
	       perror("malloc");
	       return;
	     };
	  strcpy(this_address,username);
	  strcat(this_address,"@");
	  strcat(this_address,thishost);
	  printf("You do not currently have an email address set in Whitepages\n");
	  printf("Do you wish to have %s listed as your email address? (y/n) [y]: ",this_address);
	  fgets(inputbuf,sizeof(inputbuf),stdin);
	  *(inputbuf + strlen(inputbuf) - 1) = '\0';
	  if (*inputbuf == 'y' || *inputbuf == '\0')
	    email_address = this_address;
	  else {
	       while (1)  {
		    printf("The email address must be of the form username@hostname,\n");
		    printf("where the hostname is in Internet domain format. For example,\n");
		    printf("rapatel@elbereth.rutgers.edu, or rpatel@cancer.rutgers.edu\n");
		    printf("\nEnter new address (return/enter for none): ");
		    fgets(inputbuf,sizeof(inputbuf),stdin);
		    *(inputbuf + strlen(inputbuf) - 1) = '\0';
		    if (strlen(inputbuf) > 0 ) {
			 if ( ! ( strchr(inputbuf,'@') && strchr(inputbuf,'.') ) ) {
			      printf("Please enter the address in Internet domain form or\n");
			      printf("return/enter to skip the email address.\n\n");
			      continue;
			 }
			 else {
			      email_address = malloc(strlen(inputbuf)+1);
			      strcpy(email_address,inputbuf);
			      break;
			 }
		    }
		    else {
			 email_address = NULL;
			 break;
		    }
	       }
	  }
     }
     
     while(1) {
	  printf("\nPlease enter the last 4 digits of your 9-digit Rutgers ID/SS number.\n\n");
	  printf("Enter the 4 digits here (return/enter key to quit): ");
	  fgets(inputbuf,sizeof(inputbuf),stdin);
	  *(inputbuf + strlen(inputbuf) - 1) = '\0';
	  if ( strlen(inputbuf) == 4 ) {
	       ssend = malloc(5);
	       strcpy(ssend,inputbuf);
	       break;
	  }
	  else {
	       if ( strlen(inputbuf) <=0)
		 return;
	       else
		 continue;
	  }
     }

     while(1) {
	  printf("\nPlease enter your date of birth in numeric month-day-year\n");
	  printf("format (for example 12-31-91 or 01-03-91).\n");
	  printf("Enter the birthdate (return/enter key to quit): ");
	  fgets(inputbuf,sizeof(inputbuf),stdin);
	  *(inputbuf + strlen(inputbuf) - 1) = '\0';
	  if ( strlen(inputbuf) == 8 ) {
	       bdate = malloc(9);
	       strcpy(bdate,inputbuf);
	       break;
	  }
	  else {
	       if ( strlen(inputbuf) <=0)
		 return;
	       else
		 continue;
	  }
     }
     
     i = 0;
     while (1) {
	  printf("\nPlease enter a password for WhitePages below. This password\n");
	  printf("Must be as least 6 characters/digits in length.\n");
	  printf("Should you choose something obvious, you will receive mail\n");
	  printf("Indicating that the password you chose was not acceptable.\n\n");
	  newpass = getpass("Enter password: ");
	  newpass2 = getpass("Please re-enter password to confirm: ");
	  if ( newpass && strcmp(newpass,newpass2) == 0 ) {
	       free(newpass2);
	       /* Check password... */
	       if ( strlen (newpass) < 6 ) {
		    printf("The password you have supplied is less than 6 characters/digits,\n");
		    printf("please enter one with at least 6 characters/digits long.\n");
	       }
	       else 
		 break;
	  }
	  if ( i >= 3 ) {
	       printf("Returning to main menu...\n");
	       free(newpass);
	       free(newpass2);
	       return;
	  }
	  i++;
     }
#ifndef VMS     
     printf("\nSending update request message... ");
     fflush(stdout);
     umask(077);
     mypid = getpid();
     sprintf(tempfile,"%s%d","/tmp/initsend",mypid);
     temp = fopen(tempfile,"w+");
     fprintf(temp,"%s\n",ssend);
     fprintf(temp,"%s\n",iid);
     fprintf(temp,"%s\n",bdate);
     fprintf(temp,"password=%s\n",newpass);
     if ( email_address ) {
	  fprintf(temp,"%s\n",email_address);
     }
     fclose(temp);
     if (pid = fork()) {
	  waitpid(pid,&status,0);
	  unlink(tempfile);
	  printf("Done.\nIn a few minutes, you will receive a message from daemon@whitepages.rutgers.edu\nconfirming the update or indicating any error that occurs.\n");
	  fflush(stdout);
     }
     else {
	  close(0);
	  fd = open(tempfile,O_RDWR);
	  if ( fd != 0 ) {
	       dup2(fd,0);
	       close(fd);
	  }
	  foo = execl("/usr/ucb/Mail","mail","-s",initstring,"whitepages-init@whitepages.rutgers.edu",(char *)0);
	  if ( foo < 0 ) {
	       printf("Sendmail exited with status %d\n",foo);
	       perror("execl");
	       fflush(stdout);
	       exit(foo);
	  }
	  exit(0);
     }
#else
     printf("\nSending update request message... ");
     fflush(stdout);
   
     sprintf(tempfile,"%s%d%s","sys$scratch:initsend",procid,".lis");
     temp = fopen(tempfile,"w+");
     fprintf(temp,"%s\n",ssend);
     fprintf(temp,"%s\n",iid);
     fprintf(temp,"%s\n",bdate);
     fprintf(temp,"password=%s\n",newpass);
     if ( email_address ) {
      fprintf(temp,"%s\n",email_address);
     }
     fclose(temp);
     
     sprintf(tempstring, "mail/subject=%c%c%c%s%c%c%c %s IN%%%c%c%c%s%c%c%c",
         '"','"','"',
         initstring,
         '"','"','"',
         tempfile,
         '"','"','"',
         "whitepages-init@whitepages.rutgers.edu",
         '"','"','"');
     command_desc.dsc$a_pointer = tempstring;
     command_desc.dsc$w_length = strlen(tempstring);
     stat = lib$spawn(&command_desc);
     if (stat == SS$_NORMAL) {
           printf("Done.\nIn a few minutes, you should receive a message\nat %s from daemon@whitepages.rutgers.edu\n\n",email_address);
           fflush(stdout);
      } else {
           delete(tempfile);
           exit(0);
      }
#endif
     return;
}


returnme() {
     return;
}

set_pw(person, who)
     char *person, *who;
{
     int rc;
     char *pw, *pwchk, *prompt, *temp;
     char *prefix = "New WhitePages password for ";
     char *what[2];
     extern char *search_base;
     extern char *user_name;
     extern char * getpass();
     extern char * malloc();
     
     
     /* get the first password */
     if ((prompt = malloc(strlen(prefix) + strlen(person) + 3)) == NULL) {
	  perror("malloc");
	  exit(-1);
     }
     printf("The password you supply is required to be difficult to guess,\n");
     printf("therefore if you select a known/obvious sequence of characters\,n");
     printf("you will be required to choose another. You will receive notification\n");
     printf("of this by mail if this occurs. You will then have to pick a new one\n");
     printf("and try again.\n\n");
     sprintf(prompt, "%s%s? ", prefix, person);
     do {
	  pw = getpass(prompt);
     } while (*pw == '\0');
     free(prompt);
     if ((temp = malloc(strlen(pw) + 1)) == NULL) {
	  perror("malloc");
	  exit(-1);
     }
     strcpy(temp, pw);
     
     /* re-enter to check */
     pwchk = getpass("Re-enter to confirm: "); 
     if (strcmp(temp, pwchk)) {
	  printf("Passwords do not match.  Password unchanged.\n");
	  return(-1);
     }
     free(temp);
     /* they match -- set them */
     what[0] = malloc(255);
     strcpy(what[0],"password=");
     strcat(what[0],pw);
     rc = dxi_modify(who,what);
     if ( rc == -1 ) {
	  dxi_perror("Password modification failed");
	  return(-1);
     }
     printf("WhitePages Password successfully modified.\n");
     return(0);
}

void
  update_help(iid, email_address)
char *iid, *email_address;
{
     char inputbuf[255];
     printf("\n\nYou can set the Whitepages password of your entry by electronic mail.\n");
     printf("This is done by sending mail to \"whitepages-update@whitepages.rutgers.edu\"\n");
     printf("with the Subject line set to \"Update {your unique ID}\". For example:\n\n");
     if ( iid )
       printf("Update %s\n\n",iid);
     else
       printf("Update +RP6+\n\n");
     printf("After you send the mail, you will soon receive a return message at the\n");
     printf("electronic mail address specified within your entry.\n");
     printf("Using the comments included in that message, you can then set the password\n");
     printf("for your entry and mail it back to \"whitepages-update@whitepages.rutgers.edu\".\n\n");
     if ( iid ) {
	  printf("Do you wish to have the update request sent for you? (y/n) [n]: ");
	  fgets(inputbuf,sizeof(inputbuf),stdin);
	  *(inputbuf + strlen(inputbuf) - 1) = '\0';
	  if (*inputbuf == 'y' ) {
	       update_request(iid, email_address);
	  }
     }
     return;
}

int
  update_request(iid, email_address)
char *iid, *email_address;
{
     char updatestring[25];
     int pid, status, foo,fd;
#ifdef VMS
     char tempstring[255];
     unsigned long stat;
     $DESCRIPTOR(command_desc,"");
#endif VMS

     strcpy(updatestring,"Update ");
     strcat(updatestring,iid);

#ifndef VMS     
     printf("Sending update request message...\n");
     fflush(stdout);
     
     if (pid = fork()) {
	  waitpid(pid,&status,0);
	  printf("Done.\nIn a few minutes, you should receive a message\nat %s from daemon@whitepages.rutgers.edu\n",email_address);
	  fflush(stdout);
     }
     else {
	  close(0);
	  fd = open("/dev/null",O_RDWR);
	  if ( fd != 0 ) {
	       dup2(fd,0);
	       close(fd);
	  }
	  foo = execl("/usr/ucb/Mail","mail","-s",updatestring,"whitepages-update@whitepages.rutgers.edu",(char *)0);
	  if ( foo < 0 ) {
	       printf("Sendmail exited with status %d\n",foo);
	       perror("execl");
	       fflush(stdout);
	       exit(foo);
	  }
	  exit(0);
     }
#else VMS
     printf("\nSending update request message... ");
     fflush(stdout);
     
     sprintf(tempstring, "mail/subject=%c%c%c%s%c%c%c NL: IN%%%c%c%c%s%c%c%c",
         '"','"','"',
         updatestring,
         '"','"','"',
       '"','"','"',
         "whitepages-update@whitepages.rutgers.edu",
         '"','"','"');
     command_desc.dsc$a_pointer = tempstring;
     command_desc.dsc$w_length = strlen(tempstring);
     stat = lib$spawn(&command_desc);
     if (stat == SS$_NORMAL) {
      printf("Done.\nIn a few minutes, you should receive a message\nat %s from daemon@whitepages.rutgers.edu\n\n",email_address);
      fflush(stdout);
    };
#endif VMS

     return;
}

clear_attr(sname, nohome)
     char *sname;
     int nohome;
{
     int hell_freezes_over = 1, rc, i;
     extern int print_entry();
     char *attr, c[255], *theentry, **values, *what[2];
     static char *alist[] = {"mail", "homePhone", "homePostalAddress", "description"};
     static char *alist2[] = {"mail", "description"};
     
     do {
	  attr="";
	  if ( nohome )
	    printf("\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s",
		   "Please select from the following list to clear        ",
		   "an attribute.                                         ",
		   "                                                      ",
		   "  1. E-mail Address                                   ",
		   "  2. Personal Description                             ",
		   "                                                      ",
		   "Type the number corresponding to the attribute        ",
		   "to clear or just press return/enter to quit: ");
	  else
	    printf("\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s",
		   "Please select from the following list to clear        ",
		   "an attribute.                                         ",
		   "                                                      ",
		   "  1. E-mail Address                                   ",
		   "  2. Home Telephone Number                            ",
		   "  3. Home Address                                     ",
		   "  4. Personal Description                             ",
		   "                                                      ",
		   "Type the number corresponding to the attribute        ",
		   "to clear or just press return/enter to quit: ");
	  what[0] = (char *) malloc(255);
	  what[1] = NULL;
	  fgets(c,255,stdin);
	  if ( nohome ) {
	       if (*c > '0' && *c < '3') {
		    attr=alist2[(*c-'0')-1];
		    strcpy(what[0],attr);
	       }
	       else
		 return;
	  }
	  else {
	       if (*c > '0' && *c < '5') {
		    attr=alist[(*c-'0')-1];
		    strcpy(what[0],attr);
	       }
	       else
		 return;
	  }
	  
	  rc = dxi_read (sname, readattrlist, answer);
	  /* dump the answer if OK */
	  if (rc == -1 ) {
	       dxi_perror("Read failed");
	  }
	  theentry = dxi_firstentry(answer);
	  values = dxi_getvalues(theentry,attr);
	  
	  if ( values ) {
	       printf("\nCurrent value is: ");
	       for (i=0;values[i] != NULL ; i++) {
		    printf("%s ",values[i]);
	       }
	       printf("\n\n");
	  }
	  else {
	       printf("The %s attribute is already cleared.\n",what[0]);
	       continue;
	  }
	  
	  rc = dxi_modify(sname,what);
	  if ( rc == -1) {
	       printf("Could not contact server.\n");
	       return(-1);
	  }
	  rc = dxi_read (sname, readattrlist, answer);
	  /* dump the answer if OK */
	  if (rc == -1 ) {
	       dxi_perror("Read failed");
	  }
	  else {
	       /* dump_answer3(answer, rc, sname); */
	       theentry = dxi_firstentry(answer);
	       values = dxi_getvalues(theentry,attr);
	       
	       if ( values ) {
		    printf("\nCurrent value is: ");
		    for (i=0;values[i] != NULL ; i++) {
			 printf("%s ",values[i]);
		    }
		    printf("\n\n");
	       }
	       else {
		    printf("The %s attribute has been cleared.\n",what[0]);
		    continue;
	       }
	  }
     } while (hell_freezes_over);
}
